//----------------------------------------------------------------------------
//  Project ftptree
//  OWL NExt
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    ftptree Application
//  FILE:         ftptreecl.cpp
//  AUTHOR:       Yura
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TFtpTreeDlg (TDialog).
//  (Generated by OWL 6.0 Wizard for MS VC )
//----------------------------------------------------------------------------
#include "owlpch.h"

#include "ftptreeapp.h"
#include "ftptreecl.h" // Definition of client class.


// constants
const int QUICK 		= 0;
const int DETAIL 		= 1;
const int EXPANDED 	= 2;


//{{TFtpTreeDlg Implementation}}

//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TFtpTreeDlg, TDialog)
//{{TFtpTreeDlgRSP_TBL_BEGIN}}
	EV_COMMAND(IDC_BROWSE_SITE, EvCommandBrowseSite),
	EV_TVN_ITEMEXPANDED(IDC_FTPTREE, EvItemexpandedFtptree),
	EV_COMMAND_ENABLE(IDC_LOGIN, EvCommandenableLogin),
	EV_COMMAND_ENABLE(IDC_LOGINTXT, EvCommandenableLogintxt),
	EV_COMMAND_ENABLE(IDC_PASSWTXT, EvCommandenablePasswtxt),
	EV_COMMAND_ENABLE(IDC_PASSW, EvCommandenablePassw),
	EV_COMMAND(IDC_GETFILE, EvCommandGetfile),
	EV_COMMAND_ENABLE(IDC_GETFILE, EvCommandenableGetfile),
	EV_COMMAND(IDC_PUTFILE, EvCommandPutfile),
	EV_COMMAND_ENABLE(IDC_PUTFILE, EvCommandenablePutfile),
//{{TFtpTreeDlgRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TFtpTreeDlg
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TFtpTreeDlg::TFtpTreeDlg(TWindow* parent, TResId resId, TModule* module)
:
  TDialog(parent, resId, module),
	FtpConnection(Session)
{
	XFer.FtpSite.AddString(_T("ftp.borland.com"),true);
	XFer.FtpSite.AddString(_T("ftp://ftp.microsoft.com"));
	XFer.FtpSite.AddString(_T("ftp.mmmtrol.com"));
	XFer.UserAnonim	= BF_CHECKED;
	*XFer.EditLogin = 0;
	*XFer.EditPassw = 0;

//{{TFtpTreeDlgXFER_USE}}
	// not use transfer buffer
	FtpTree		 = new TTreeWindow(this, IDC_FTPTREE);

	FtpSite		 = new TComboBox(this, IDC_FTPSITE, 0);
	UserAnonim = new TCheckBox(this, IDC_USEANONIM, 0);
	EditLogin  = new TEdit(this, IDC_LOGIN, 255);
	EditPassw  = new TEdit(this, IDC_PASSW, 255);
//{{TFtpTreeDlgXFER_USE_END}}

	SetTransferBuffer(&XFer);


	// INSERT>> Your constructor code here.

	ImageList = new TImageList(*GetApplication(), IDB_TREEIMAGE,
                             18, 1, TColor(255, 255, 255), IMAGE_BITMAP, 0);
}
//
TFtpTreeDlg::~TFtpTreeDlg()
{
  Destroy();
  delete ImageList;
}
//
void TFtpTreeDlg::SetupWindow()
{
	// Call base class function.
	TDialog::SetupWindow();

	Session.Open(GetApplication()->GetName(), TInternetSession::OpenPreconfig);
	if(!Session.IsOpen()){
		MessageBox("Fail to open session");
		PostMessage(WM_CLOSE);
		return;
	}

  FtpTree->SetImageList(TTreeWindow::Normal, *ImageList);
	PopulateTree();
}
//
void TFtpTreeDlg::CleanupWindow()
{
	// Call base class function.
	TDialog::CleanupWindow();

	if (FtpConnection.IsOpen())
		FtpConnection.Close();
	if (Session.IsOpen())
		Session.Close();
}
//
void TFtpTreeDlg::EvCommandBrowseSite()
{
	// OnBrowseSite() provides some basic error-checking before
	// passing a pointer to a FtpConnection (and possibly a path
	// to expand) to the tree control

	if (FtpConnection.IsOpen())
		FtpConnection.Close();

	TTmpBuffer<_TCHAR> buffer1(MAX_PATH);
	TTmpBuffer<_TCHAR> buffer2(MAX_PATH);

	FtpSite->GetWindowText(buffer1, MAX_PATH);

	// update the combo box so the most recently used URL is at the top
	int count = FtpSite->GetCount();
	while (count > 0){
		FtpSite->GetString(buffer2, --count);
		if (_tcsicmp(buffer1,buffer2) == 0){
			FtpSite->DeleteString(count);
			count = 0;
		}
	}

	FtpSite->InsertString(buffer1, 0);

	// the combo box might have 6 entries now; if so, delete the last one
	if (FtpSite->GetCount() > 5)
		FtpSite->DeleteString(5);


	//owl_string strFtpSite;
    owl_string strServerName = (_TCHAR*)buffer1;
	owl_string strObject;

	INTERNET_PORT nPort;
	TInternetService serviceType;

	// check to see if this is a reasonable URL --
	// ie "ftp://servername/dirs" or just "servername/dirs"
	if (!TInternetConnection::ParseURL(buffer1, serviceType, strServerName, strObject, nPort)){
		// try adding the "ftp://" protocol
		owl_string strFtpURL = _T("ftp://");
		strFtpURL += buffer1;

		if (!TInternetConnection::ParseURL(strFtpURL.c_str(), serviceType,
			                                 strServerName, strObject, nPort)){
			owl_string mesage = GetApplication()->LoadString(IDS_INVALID_URL);
			MessageBox(mesage.c_str(), 0, MB_OK);
			PopulateTree();
			return;
		}
	}

	TWaitCursor w; // this will automatically display a wait cursor

	// replace the MRU URL in the combo's edit box
	FtpSite->SetWindowText(buffer1);
	FtpSite->SetEditSel(-1,-1);

	// Now open an annonymous FTP connection to the server
	if((serviceType == isServiceFtp) && !strServerName.empty()){
		if(UserAnonim->GetCheck() == BF_CHECKED){
			FtpConnection.Open(strServerName.c_str(),INTERNET_DEFAULT_FTP_PORT);
		}
		else{

			EditLogin->GetText(buffer1,MAX_PATH);
			EditPassw->GetText(buffer2,MAX_PATH);
			FtpConnection.Open(strServerName.c_str(),
				                 INTERNET_DEFAULT_FTP_PORT,
												 buffer1,buffer2);
		}
	}

	// PopulateTree() will display an error if the FTP connection
	// could not be made, otherwise, it grabs the root listing
	// and expands any folder indicated by the site name

	if (FtpConnection.IsOpen())
		PopulateTree(strObject.c_str());
	else
		PopulateTree();
}
//
void TFtpTreeDlg::PopulateTree(LPCTSTR strDir)
{
	// Make sure tree is empty before (re)populating it
	FtpTree->DeleteAllItems();

	// If CFtpConnection is NULL, display error in tree
	if(!strDir){
		// change style -- remove TVS_LINESATROOT if it is currently set
		FtpTree->ModifyStyle(TVS_LINESATROOT, 0);

		TTreeNode root = FtpTree->GetRoot();
		root.AddSibling(TTreeNode(*FtpTree, _T("An FTP connection has not been established."),0,0));
	}
	else{
		TTreeNode root = FtpTree->GetRoot();
		// insert the the root into the tree struct
		TTreeNode child = root.AddSibling(TTreeNode(*FtpTree, strDir,1,1));

		// the root dir needs to think it has children for Expand() to work
		// Expand() will call ExploreDir() to find the root's real children
		TTreeNode node(*FtpTree, _T("!"), 0, 0);
    node.SetItemData(QUICK, false);
		child.AddChild(node);
		
		child.ExpandItem(TVE_EXPAND);

		// if the root has no real children, make sure TVS_LINESATROOT is not set
		if(!child.GetChild()){
			FtpTree->ModifyStyle(TVS_LINESATROOT, 0);
		}    
		else  // otherwise, there are children, so set TVS_LINESATROOT
			FtpTree->ModifyStyle(0, TVS_LINESATROOT);
	}
}
//
//void TFtpTreeDlg::ExploreDir(LPCTSTR path, TTreeNode& node, int mode)
void TFtpTreeDlg::ExploreDir(LPCTSTR path, TTreeNode& newNode, int mode)
{
  // by default we will be using image 1 for the node and
  // image 2 for the selected node, if it is dir

 	// need a string object to build the directory path
 	owl_string searchPath;
	// first, build a path name based on the node and add wildcards
 	BuildPath(searchPath, newNode);
	searchPath += _T("*.*");
	
	TFtpFileNameIterator itr(FtpConnection, searchPath);
	//TFileNameIterator itr(searchPath);
	while(itr){
  	if((*itr).attribute & TFile::Directory){
			if (_tcscmp(itr, _T(".")) == 0)
				; // don't want it
			else if (_tcscmp(itr, _T("..")) == 0)
				; // don't want this either
			else {
				TTreeNode node1(*FtpTree, itr, 1, 2);
		    node1.SetItemData(QUICK, false);
				node1 = newNode.InsertChild(node1,TTreeNode::Sort );
				
				// add placeholder
				TTreeNode child(*FtpTree, "!", 0, 0);
		    child.SetItemData(QUICK, false);
				node1.InsertChild(child, TTreeNode::Sort);
				
				// update the tree so that we can see the nodes being added
      	FtpTree->UpdateWindow();

				// only want one sub-node per node for now in the QUICK mode
				if (mode == QUICK)
        	break;
			}
    }
		else{
			TTreeNode child(*FtpTree, itr, 3, 3);
		  child.SetItemData(EXPANDED, false);
			newNode.InsertChild(child, TTreeNode::Sort);

			// update the tree so that we can see the nodes being added
     	FtpTree->UpdateWindow();

			// only want one sub-node per node for now in the QUICK mode
			if (mode == QUICK)
       	break;
		}

    ++itr;
  }
	return;
}
//
void TFtpTreeDlg::EvItemexpandedFtptree(TTwNotify far& not)
{	
	TTreeNode node(*FtpTree, not.itemNew);
  
	TWaitCursor w; // this will automatically display a wait cursor

	// if the node was contracted then set the item data so that
  // later we know not to rebuild the node.
	if (not.action == TVE_COLLAPSE) {
    node.SetItemData(EXPANDED, true); // send now
  	return;
  }
	// If the node was already built once then we don't need to do
  // it again. If we do, we'll have duplicate entries
	uint32 data; 
  if (node.GetItemData(data) && (data == EXPANDED))
  	return;

	// remove the first child because we're going to add it again
  // remember that we have to have already added one child per
  // node so that the plus sign gets added to the node
  TTreeNode child = node.GetChild();
  child.Delete();

  // add this node and all subnodes
  ExploreDir(0, node, DETAIL);

	return;
}
//
// BuildPath(). This function builds the path name by recursing
// backwards through the tree. Use the string class to make
// manipulation of the string easy.
void TFtpTreeDlg::BuildPath(owl_string& path, TTreeNode& node)
{
	// build up the path to htreeitem
	TTmpBuffer<_TCHAR> buffer1(MAX_PATH);
	TTmpBuffer<_TCHAR> buffer2(MAX_PATH);

	node.GetText(buffer1, MAX_PATH);

	if(_tcscmp(buffer1,_T("/"))==0)
		_tcscpy(buffer1,_T(""));

	TTreeNode curnode = node;
	while (curnode){
		curnode = curnode.GetParent();

		if (!curnode)
			wsprintf(buffer2, _T("%s/"), (LPTSTR)buffer1);
		else{
			LPCTSTR p = _T("");
			if(_tcscmp(curnode.GetText(),_T("/"))!=0)
				p = curnode.GetText();

			wsprintf(buffer2, _T("%s/%s"), p, (LPTSTR)buffer1);
		}
		_tcscpy(buffer1, buffer2);
	}
	path = buffer1;
}
///
void TFtpTreeDlg::EvCommandenableLogin(TCommandEnabler& tce)
{	
	// INSERT>> Your code here.
	tce.Enable(UserAnonim->GetCheck() != BF_CHECKED);
}
//
void TFtpTreeDlg::EvCommandenableLogintxt(TCommandEnabler& tce)
{	
	// INSERT>> Your code here.
	tce.Enable(UserAnonim->GetCheck() != BF_CHECKED);
}
//
void TFtpTreeDlg::EvCommandenablePasswtxt(TCommandEnabler& tce)
{	
	// INSERT>> Your code here.
	tce.Enable(UserAnonim->GetCheck() != BF_CHECKED);
}
//
void TFtpTreeDlg::EvCommandenablePassw(TCommandEnabler& tce)
{	
	// INSERT>> Your code here.
	tce.Enable(UserAnonim->GetCheck() != BF_CHECKED);
}
//
void TFtpTreeDlg::EvCommandGetfile()
{	
	// INSERT>> Your code here.
}
//
void TFtpTreeDlg::EvCommandenableGetfile(TCommandEnabler& tce)
{	
	// INSERT>> Your code here.
}
//
void TFtpTreeDlg::EvCommandPutfile()
{	
	// INSERT>> Your code here.
}
//
void TFtpTreeDlg::EvCommandenablePutfile(TCommandEnabler& tce)
{	
	// INSERT>> Your code here.
	tce.Enable(FtpConnection.IsOpen());
}
//