//----------------------------------------------------------------------------
//  Project ftptree
//  OWL NExt
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    ftptree Application
//  FILE:         ftptreecl.h
//  AUTHOR:       Yura
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TFtpTreeDlg (TDialog).
//  (Generated by OWL 6.0 Wizard for VC.)
//----------------------------------------------------------------------------
#if !defined(ftptreecl_h)              // Sentry, use file only if it's not already included.
#define ftptreecl_h

#include "resource.h"                  // Definition of all resources.

#include <owl/combobox.h>
#include <owl/treewind.h>
#include <owl/imagelst.h>
#include <owl/checkbox.h>
#include <owl/edit.h>
#include "internet.h"

//{{TDialog = TFtpTreeDlg}}

struct TFtpTreeDlgXfer{
//{{TFtpTreeDlgXFER_DATA}}
	TComboBoxData FtpSite;
	uint16 UserAnonim;
	_TCHAR EditLogin[ 255 ];
	_TCHAR EditPassw[ 255 ];
//{{TFtpTreeDlgXFER_DATA_END}}
};

class TFtpTreeDlg : public TDialog {
  public:
    TFtpTreeDlg(TWindow* parent, TResId resId = IDD_CLIENT, TModule* module = 0);
    virtual ~TFtpTreeDlg();

		void PopulateTree(LPCTSTR strDir=0);
		void ExploreDir(LPCTSTR strDir, TTreeNode& node, int mode);
		void BuildPath(owl_string& path, TTreeNode& node);

//{{TFtpTreeDlgXFER_DEF}}
	protected:
		TComboBox*		FtpSite;
		TCheckBox*		UserAnonim;
		TTreeWindow*	FtpTree;
		TEdit*	EditLogin;
		TEdit*	EditPassw;
//{{TFtpTreeDlgXFER_DEF_END}}

//{{TFtpTreeDlgVIRTUAL_BEGIN}}
		public:
			void SetupWindow();
			void CleanupWindow();
//{{TFtpTreeDlgVIRTUAL_END}}

//{{TFtpTreeDlgRSP_TBL_BEGIN}}
	protected:
		void EvCommandBrowseSite();
		void EvItemexpandedFtptree(TTwNotify far& not);
		void EvCommandenableLogin(TCommandEnabler& tce);
		void EvCommandenableLogintxt(TCommandEnabler& tce);
		void EvCommandenablePasswtxt(TCommandEnabler& tce);
		void EvCommandenablePassw(TCommandEnabler& tce);
		void EvCommandGetfile();
		void EvCommandenableGetfile(TCommandEnabler& tce);
		void EvCommandPutfile();
		void EvCommandenablePutfile(TCommandEnabler& tce);
//{{TFtpTreeDlgRSP_TBL_END}}

	protected:
		TInternetSession	Session; 
		TFtpConnection		FtpConnection;
		TImageList*				ImageList;
		TFtpTreeDlgXfer		XFer;


DECLARE_RESPONSE_TABLE(TFtpTreeDlg);
};    //{{TFtpTreeDlg}}

#endif  // ftptreecl_h sentry.
